' This class is "generated" and will be overwritten.
' Your customizations should be made in PersonalRankRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="PersonalRankRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="PersonalRankTable"></see> class.
''' </remarks>
''' <seealso cref="PersonalRankTable"></seealso>
''' <seealso cref="PersonalRankRecord"></seealso>

<Serializable()> Public Class BasePersonalRankRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As PersonalRankTable = PersonalRankTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub PersonalRankRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim PersonalRankRec As PersonalRankRecord = CType(sender,PersonalRankRecord)
        Validate_Inserting()
        If Not PersonalRankRec Is Nothing AndAlso Not PersonalRankRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub PersonalRankRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim PersonalRankRec As PersonalRankRecord = CType(sender,PersonalRankRecord)
        Validate_Updating()
        If Not PersonalRankRec Is Nothing AndAlso Not PersonalRankRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub PersonalRankRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim PersonalRankRec As PersonalRankRecord = CType(sender,PersonalRankRecord)
        If Not PersonalRankRec Is Nothing AndAlso Not PersonalRankRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.id field.
	''' </summary>
	Public Function Getid0Value() As ColumnValue
		Return Me.GetValue(TableUtils.id0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.id field.
	''' </summary>
	Public Function Getid0FieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.id0Column).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.PersonalId field.
	''' </summary>
	Public Function GetPersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.PersonalId field.
	''' </summary>
	Public Function GetPersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PersonalId field.
	''' </summary>
	Public Sub SetPersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PersonalId field.
	''' </summary>
	Public Sub SetPersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Function GetPreRankValue() As ColumnValue
		Return Me.GetValue(TableUtils.PreRankColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Function GetPreRankFieldValue() As Byte
		Return CType(Me.GetValue(TableUtils.PreRankColumn).ToByte(), Byte)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Sub SetPreRankFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PreRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Sub SetPreRankFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PreRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Sub SetPreRankFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PreRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Sub SetPreRankFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PreRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Sub SetPreRankFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PreRankColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Function GetRankIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Function GetRankIdFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.RankIdColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.RankDate field.
	''' </summary>
	Public Function GetRankDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.RankDate field.
	''' </summary>
	Public Function GetRankDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.RankDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankDate field.
	''' </summary>
	Public Sub SetRankDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankDate field.
	''' </summary>
	Public Sub SetRankDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RankDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RankDate field.
	''' </summary>
	Public Sub SetRankDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.RefDate field.
	''' </summary>
	Public Function GetRefDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.RefDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.RefDate field.
	''' </summary>
	Public Function GetRefDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.RefDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RefDate field.
	''' </summary>
	Public Sub SetRefDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RefDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RefDate field.
	''' </summary>
	Public Sub SetRefDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RefDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.RefDate field.
	''' </summary>
	Public Sub SetRefDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RefDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.Ref field.
	''' </summary>
	Public Function GetRef0Value() As ColumnValue
		Return Me.GetValue(TableUtils.Ref0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.Ref field.
	''' </summary>
	Public Function GetRef0FieldValue() As String
		Return CType(Me.GetValue(TableUtils.Ref0Column).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.Ref field.
	''' </summary>
	Public Sub SetRef0FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Ref0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.Ref field.
	''' </summary>
	Public Sub SetRef0FieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Ref0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazetteNO field.
	''' </summary>
	Public Function GetGazetteNOValue() As ColumnValue
		Return Me.GetValue(TableUtils.GazetteNOColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazetteNO field.
	''' </summary>
	Public Function GetGazetteNOFieldValue() As String
		Return CType(Me.GetValue(TableUtils.GazetteNOColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteNO field.
	''' </summary>
	Public Sub SetGazetteNOFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.GazetteNOColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteNO field.
	''' </summary>
	Public Sub SetGazetteNOFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GazetteNOColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazetteSection field.
	''' </summary>
	Public Function GetGazetteSectionValue() As ColumnValue
		Return Me.GetValue(TableUtils.GazetteSectionColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazetteSection field.
	''' </summary>
	Public Function GetGazetteSectionFieldValue() As String
		Return CType(Me.GetValue(TableUtils.GazetteSectionColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteSection field.
	''' </summary>
	Public Sub SetGazetteSectionFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.GazetteSectionColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteSection field.
	''' </summary>
	Public Sub SetGazetteSectionFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GazetteSectionColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazettePage field.
	''' </summary>
	Public Function GetGazettePageValue() As ColumnValue
		Return Me.GetValue(TableUtils.GazettePageColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazettePage field.
	''' </summary>
	Public Function GetGazettePageFieldValue() As String
		Return CType(Me.GetValue(TableUtils.GazettePageColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazettePage field.
	''' </summary>
	Public Sub SetGazettePageFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.GazettePageColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazettePage field.
	''' </summary>
	Public Sub SetGazettePageFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GazettePageColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazetteDate field.
	''' </summary>
	Public Function GetGazetteDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.GazetteDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalRank_.GazetteDate field.
	''' </summary>
	Public Function GetGazetteDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.GazetteDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteDate field.
	''' </summary>
	Public Sub SetGazetteDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.GazetteDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteDate field.
	''' </summary>
	Public Sub SetGazetteDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.GazetteDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalRank_.GazetteDate field.
	''' </summary>
	Public Sub SetGazetteDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GazetteDateColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.id field.
	''' </summary>
	Public Property id0() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.id0Column).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.id0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property id0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.id0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property id0Default() As String
        Get
            Return TableUtils.id0Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.PersonalId field.
	''' </summary>
	Public Property PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalIdDefault() As String
        Get
            Return TableUtils.PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.PreRank field.
	''' </summary>
	Public Property PreRank() As Byte
		Get 
			Return CType(Me.GetValue(TableUtils.PreRankColumn).ToByte(), Byte)
		End Get
		Set (ByVal val As Byte) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PreRankColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PreRankSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PreRankColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PreRankDefault() As String
        Get
            Return TableUtils.PreRankColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.RankId field.
	''' </summary>
	Public Property RankId() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.RankIdColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RankIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankIdDefault() As String
        Get
            Return TableUtils.RankIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.RankDate field.
	''' </summary>
	Public Property RankDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.RankDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RankDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankDateDefault() As String
        Get
            Return TableUtils.RankDateColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.RefDate field.
	''' </summary>
	Public Property RefDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.RefDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RefDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RefDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RefDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RefDateDefault() As String
        Get
            Return TableUtils.RefDateColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.Ref field.
	''' </summary>
	Public Property Ref0() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Ref0Column).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Ref0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Ref0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Ref0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Ref0Default() As String
        Get
            Return TableUtils.Ref0Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.GazetteNO field.
	''' </summary>
	Public Property GazetteNO() As String
		Get 
			Return CType(Me.GetValue(TableUtils.GazetteNOColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.GazetteNOColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property GazetteNOSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.GazetteNOColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property GazetteNODefault() As String
        Get
            Return TableUtils.GazetteNOColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.GazetteSection field.
	''' </summary>
	Public Property GazetteSection() As String
		Get 
			Return CType(Me.GetValue(TableUtils.GazetteSectionColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.GazetteSectionColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property GazetteSectionSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.GazetteSectionColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property GazetteSectionDefault() As String
        Get
            Return TableUtils.GazetteSectionColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.GazettePage field.
	''' </summary>
	Public Property GazettePage() As String
		Get 
			Return CType(Me.GetValue(TableUtils.GazettePageColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.GazettePageColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property GazettePageSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.GazettePageColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property GazettePageDefault() As String
        Get
            Return TableUtils.GazettePageColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalRank_.GazetteDate field.
	''' </summary>
	Public Property GazetteDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.GazetteDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.GazetteDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property GazetteDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.GazetteDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property GazetteDateDefault() As String
        Get
            Return TableUtils.GazetteDateColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
